#ifndef _FIRST_H
#define _FIRST_H

#include <vector>
#include <set>
#include <map>
#include <cmath>
#include <cassert>
#define NOT_IMPLEMENTED_YET { cerr << "NOT_IMPLEMENTED_YET\n"; assert(false); }
#define NOT_REACHED { cerr << "NOT_REACHED\n"; assert(false); }

using namespace std;
typedef pair<int, int> intpair;
typedef pair<double, double> doublepair;

// ??? These constants are heursitics and can be tweaked by me based on some criteria
// leak prob assuming leak group size is 1. Since we take sqrt in this version, the actual leak prob is INITLEAKPERVAR * sqrt(leakgroup size)
const double INITLEAKPERVAR = 0.0001;
// leak prob for leaktype 0 when we only have one leak variable
const double INITLEAK0PROB = 0.01;
// minimum factor of improvement in joint probability that has to be acheived
//   at every check in order to continue iteration
// Switched from base-10 log to natural log so the threshold scaled accordingly
extern double IMPROVETHRESH;

#endif // _FIRST_H
