#ifndef _MYCLIB_IO_H
#define _MYCLIB_IO_H

#include <iostream>
#include <fstream>
#include <vector>
#include <set>

using namespace std;

// put user (public) interface here
namespace Mylib {
  class FileOpenErr {};
  class FilExistErr {};
  // Open a file. Close it first if necessary. Throw exception if open is no good.
  void InFopen(ifstream & infile, const char * fname) throw(FileOpenErr);
  void InFopen(ifstream & infile, const string & fname) throw(FileOpenErr);
  // Safely open a file. Close it first if necessary. Throw exception if the file exists already or open is no good.
  void OutFopen(ofstream & outfile, const char * fname) throw(FileOpenErr, FilExistErr);
  // output fields in data joined by sep like in perl
  void PrintJoin(ostream & out, const vector<int> & data, const char * sep);
  void PrintJoin(ostream & out, const vector<double> & data, const char * sep);
  void PrintJoin(ostream & out, const set<int> & data, const char * sep);
  void PrintJoin(ostream & out, const set<double> & data, const char * sep);
}

#endif
